#include <amxmodx>
#include <engine>
#include <cstrike>
#include <superheromod>

// VARIABLES

#define use_cmath 0

#if use_cmath == 1
#include <cmath>
new Float:fAngle 
#define DT 0.1 
#define PI 3.1415926535897932384626433832795 
#endif

new gHeroName[]="Copter"
new bool:g_HasCopterPowers[SH_MAXSLOTS+1]
new bool:g_morphed[SH_MAXSLOTS+1]

new beam, boom, ls_dot
new bool:cstrike_running
new DoOnce
new round_st
new has_rocket[33]
/* missile_inv:  fake,guncam,laserguide,heatseeker,normal,antimissile,ropeseeking,multimissile */
new missile_inv[33][8] 
new missile_win[33]
new using_menu[33]
new is_scan_rocket[33]
new is_heat_rocket[33]
new radar_batt[33]
new tkcount[33]
new Float:user_sdmf[33]
new cmd_jetpackrun[33]
new cmd_onrope[33]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Copter",".75","SRGrty")
 
  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create Copter Hero")
  register_cvar("Copter_level", "1" )
  shCreateHero(gHeroName, "Copter", "Changes to hellicopter! Fires Misiles too", true, "Copter_level" )
  
  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  // INIT
  register_srvcmd("Copter_init", "Copter_init")
  shRegHeroInit(gHeroName, "Copter_init")
  
  // 
  register_event("ResetHUD","newRound","b")
  
  //MISSILE MENU
  register_menucmd(register_menuid("Fire Missile Menu"),1023,"action_main_menu")
   
  // KEY DOWN
  register_srvcmd("Copter_kd", "Copter_kd")
  shRegKeyDown(gHeroName, "Copter_kd")

  register_clcmd("Copter_guncamera_missile","fire_missile")
  register_clcmd("Copter_laserguided_missile","fire_missile")
  register_clcmd("Copter_heatseeking_missile","fire_missile")
  register_clcmd("Copter_missile","fire_missile")
  register_clcmd("Copter_anti_missile","fire_missile")
  register_clcmd("Copter_ropeseeking_missile","fire_missile")
  #if use_cmath == 1
  register_clcmd("Copter_swirlingdeath_missile","fire_missile")
  #endif
  
  // Events
  register_event("SendAudio","round_end","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")
  register_event("TextMsg","round_end","a","2&#Game_C","2&#Game_w")
  register_event("DeathMsg","Copter_death","a")
  
  //MISSILE CHECKS
  register_srvcmd("lasermissile_chk","ls_missile_ck")
  register_srvcmd("jetpackmissile_chk","jp_missile_ck")
  register_srvcmd("ropemissile_chk","rp_missile_ck")
  
  // DEFAULT THE CVARS
  register_cvar("Copter_cooldown", "45" )
  
  register_cvar("Copter_missile_buy","1")
  //set_cvar_string("Copter_missile_buy","10")
  register_cvar("Copter_missile_fuel","6.0")
  //set_cvar_float("Copter_missile_fuel",6.0)
  register_cvar("Copter_missile_sdfuel","2.0")
  //set_cvar_float("Copter_missile_sdfuel",2.0)
  register_cvar("Copter_missile_sdcount","6")
  //set_cvar_string("Copter_missile_sdcount","6")
  register_cvar("Copter_missile_sdrotate","6")
  //set_cvar_string("Copter_missile_sdrotate","6")
  register_cvar("Copter_missile_sdradius","32")
  //set_cvar_string("Copter_missile_sdradius","32")
  register_cvar("Copter_missile_ammo1","10")
  //set_cvar_string("Copter_missile_ammo1","10")
  register_cvar("Copter_missile_ammo2","10")
  //set_cvar_string("Copter_missile_ammo2","10")
  register_cvar("Copter_missile_ammo3","10")
  //set_cvar_string("Copter_missile_ammo3","10")
  register_cvar("Copter_missile_ammo4","20")
  //set_cvar_string("Copter_missile_ammo4","20")
  register_cvar("Copter_missile_ammo5","10")
  //set_cvar_string("Copter_missile_ammo5","10")
  register_cvar("Copter_missile_ammo6","10")
  //set_cvar_string("Copter_missile_ammo6","10")
  register_cvar("Copter_missile_ammo7","10")
  //set_cvar_string("Copter_missile_ammo7","10")
  register_cvar("Copter_missile_ammo7takeall","10")
  //set_cvar_string("Copter_missile_ammo7takeall","10")
  register_cvar("Copter_missile_cost1","10")
  //set_cvar_string("Copter_missile_cost1","10")
  register_cvar("Copter_missile_cost2","10")
  //set_cvar_string("Copter_missile_cost2","10")
  register_cvar("Copter_missile_cost3","10")
  //set_cvar_string("Copter_missile_cost3","10")
  register_cvar("Copter_missile_cost4","10")
  //set_cvar_string("Copter_missile_cost4","10")
  register_cvar("Copter_missile_cost5","10")
  //set_cvar_string("Copter_missile_cost5","10")
  register_cvar("Copter_missile_cost6","10")
  //set_cvar_string("Copter_missile_cost6","10")
  register_cvar("Copter_missile_cost7","10")
  //set_cvar_string("Copter_missile_cost7","10")
  register_cvar("Copter_missile_speed","1000")
  //set_cvar_string("Copter_missile_speed","1000")
  register_cvar("Copter_missile_sdspeed","750")
  //set_cvar_string("Copter_missile_sdspeed","750")
  register_cvar("Copter_missile_hsspeed","1100")
  //set_cvar_string("Copter_missile_hsspeed","1100")
  register_cvar("Copter_missile_rsspeed","1400")
  //set_cvar_string("Copter_missile_rsspeed","1400")
  register_cvar("Copter_missile_obeygravity","1")
  //set_cvar_string("Copter_missile_obeygravity","1")
  register_cvar("Copter_missile_damradius1","50")
  //set_cvar_string("Copter_missile_damradius1","50")
  register_cvar("Copter_missile_damradius2","50")
  //set_cvar_string("Copter_missile_damradius2","50")
  register_cvar("Copter_missile_damradius3","50")
  //set_cvar_string("Copter_missile_damradius3","50")
  register_cvar("Copter_missile_radiusdam1","50")
  //set_cvar_string("Copter_missile_radiusdam1","50")
  register_cvar("Copter_missile_radiusdam2","50")
  //set_cvar_string("Copter_missile_radiusdam2","50")
  register_cvar("Copter_missile_radiusdam3","25")
  //set_cvar_string("Copter_missile_radiusdam3","25")
  register_cvar("Copter_missile_obeyffcvar","1")
  //set_cvar_string("Copter_missile_obeyffcvar","1")
  register_cvar("Copter_missile_tkpunish1","0")
  //set_cvar_string("Copter_missile_tkpunish1","1")
  register_cvar("Copter_missile_tkpunish2","0")
  //set_cvar_string("Copter_missile_tkpunish2","3")
  register_cvar("Copter_missile_prizes","0")
  //set_cvar_string("Copter_missile_prizes","5")
  register_cvar("Copter_missile_radarbattery","100")
  //set_cvar_string("Copter_missile_radarbattery","100")
  register_cvar("Copter_missile_atspawn","0")
  //set_cvar_string("Copter_missile_atspawn","0")
  
  if ( !cvar_exists("Copter_gravity") ) register_cvar("Copter_gravity", ".01" )
    
  shSetMinGravity(gHeroName, "Copter_gravity" )
  
  //MAKE SURE THIS IS CS
  new mod_name[32]
  get_modname(mod_name,31)
  cstrike_running = equal(mod_name,"cstrike") ? true : false
	
  //SWIRLING DEATH MISSILES
  #if use_cmath == 1
  set_task(0.1,"RocketThink",30500,"",0,"b")
  #endif
  return PLUGIN_CONTINUE 
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
  precache_sound("vox/_period.wav")
  precache_sound("debris/beamstart8.wav")
  precache_sound("weapons/explode3.wav")
  precache_sound("weapons/rocketfire1.wav") 
  precache_sound("ambience/rocket_steam1.wav") 
  precache_sound("weapons/rocket1.wav") 
  precache_sound("ambience/particle_suck2.wav") 
  precache_model("models/rpgrocket.mdl")
  precache_model("models/player/Copter/Copter.mdl")

  beam = precache_model("sprites/smoke.spr")
  boom = precache_model("sprites/zerogxplode.spr")
  ls_dot = precache_model("sprites/laserdot.spr")
  return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
  gPlayerUltimateUsed[id]=false
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public Copter_init()
{
  new temp[128]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)
  
  // 2nd Argument is 0 or 1 depending on whether the id has wolverine skills
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  if ( hasPowers )
   g_HasCopterPowers[id]=true
  else
   g_HasCopterPowers[id]=false  
  
  // Got to slow down a Flash that lost his powers...
  if ( !hasPowers )
  {
    shRemGravityPower(id)
  }
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public Copter_kd() 
{ 
  new temp[6]
  
  // First Argument is an id with Copter Powers!
  read_argv(1,temp,5)
  new id=str_to_num(temp) 
 
  // Let them know they already used their ultimate if they have
  if ( gPlayerUltimateUsed[id] )
  {
    playSoundDenySelect(id)
    return PLUGIN_HANDLED 
  } 
  
  new CopterCooldown=get_cvar_num("copter_cooldown")
  if ( CopterCooldown>0 )ultimateTimer(id, CopterCooldown * 1.0 )
  
  Copter_morph(id)
  
  show_main_menu(id)
  
  return PLUGIN_HANDLED 
} 
public client_connect(id){
	is_scan_rocket[id] = 0
	is_heat_rocket[id] = 0
	using_menu[id] = 0
	has_rocket[id] = 0
	missile_win[id] = 0
	if(get_cvar_num("Copter_missile_buy") == 0){
		missile_inv[id][1] = get_cvar_num("Copter_missile_ammo1")
		missile_inv[id][2] = get_cvar_num("Copter_missile_ammo2")
		missile_inv[id][3] = get_cvar_num("Copter_missile_ammo3")
		missile_inv[id][4] = get_cvar_num("Copter_missile_ammo4")
		missile_inv[id][5] = get_cvar_num("Copter_missile_ammo5")
		missile_inv[id][6] = get_cvar_num("Copter_missile_ammo6")
		missile_inv[id][7] = get_cvar_num("Copter_missile_ammo7")
	}
	radar_batt[id] = get_cvar_num("Copter_missile_radarbattery")
	tkcount[id] = 0
	user_sdmf[id] = 0.0
	cmd_jetpackrun[id] = 0
	cmd_onrope[id] = 0
	return PLUGIN_CONTINUE
}

public client_disconnect(id){
	remove_task(35632+id)
	is_scan_rocket[id] = 0
	is_heat_rocket[id] = 0
	has_rocket[id] = 0
	tkcount[id] = 0
	user_sdmf[id] = 0.0
	cmd_jetpackrun[id] = 0
	cmd_onrope[id] = 0
	return PLUGIN_CONTINUE
}

public vexd_pfntouch(pToucher, pTouched) {
	new szClassName[32]
	get_string(pToucher, szClassName, 31)
	if(equal(szClassName, "lud_missile")) {
		new radius1 = get_cvar_num("Copter_missile_damradius1")
		new radius2 = get_cvar_num("Copter_missile_damradius2")
		new radius3 = get_cvar_num("Copter_missile_damradius3")
		new dam1 = get_cvar_num("Copter_missile_radiusdam1")
		new dam2 = get_cvar_num("Copter_missile_radiusdam2")
		new dam3 = get_cvar_num("Copter_missile_radiusdam3")
		remove_task(2020+pToucher)
		emit_sound(pToucher, CHAN_WEAPON, "weapons/explode3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
		emit_sound(pToucher, CHAN_VOICE, "weapons/explode3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		new Float:fl_vExplodeAt[3]
		entity_get_vector(pToucher, EV_VEC_origin, fl_vExplodeAt)
		new vExplodeAt[3]
		vExplodeAt[0] = floatround(fl_vExplodeAt[0])
		vExplodeAt[1] = floatround(fl_vExplodeAt[1])
		vExplodeAt[2] = floatround(fl_vExplodeAt[2])
		new id = entity_get_edict(pToucher, EV_ENT_owner)
		new unarmed = missile_inv[id][0]
		attach_view(id, id)
		if(has_rocket[id] == pToucher)
			has_rocket[id] = 0
		new origin[3]
		new maxplayers = get_maxplayers()+1
		for (new i=1; i<=maxplayers; i++) {
			if(DoOnce == 0){
				if((cvar_exists("mp_friendlyfire")) && (unarmed !=2) ){
					if( (get_cvar_num("mp_friendlyfire") == 1) && (get_cvar_num("Copter_missile_obeyffcvar") == 1) ){
						if((is_user_alive(i) == 1) && (i != id)){
							get_user_origin(i,origin)
							new dist = get_distance(origin,vExplodeAt)
							if(get_user_team(i) != get_user_team(id)){
								if(dist < radius1) {
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam1,unarmed,0)
									}
								}else if(dist < radius2){
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam2,unarmed,0)
									}
								}else if(dist < radius3){
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam3,unarmed,0)
									}
								}
							}else{
								if(dist < radius1) {
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam1,unarmed,1)
									}
								}else if(dist < radius2) {
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam2,unarmed,1)
									}
								}else if(dist < radius3) {
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam3,unarmed,0)
									}
								}
							}
						}				
					}else{
						if(get_user_team(i) != get_user_team(id)){
							if((is_user_alive(i) == 1) && (i != id)){
								get_user_origin(i,origin)
								new dist = get_distance(origin,vExplodeAt)
								if(dist < radius1){
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam1,unarmed,0)
									}
								}else if(dist < radius2){
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam2,unarmed,0)
									}
								}else if(dist < radius3){
									if (get_user_godmode(id)!=1) {
										do_victim(i,id,dam3,unarmed,0)
									}
								}
							}
						}
					}
				}else{
					if((is_user_alive(i) == 1) && (i != id)){
						get_user_origin(i,origin)
						new dist = get_distance(origin,vExplodeAt)
						if(dist < radius1) {
							if (get_user_godmode(id)!=1) {
								do_victim(i,id,1,unarmed,0)
							}
						}else if(dist < radius2) {
							if (get_user_godmode(id)!=1) {
								do_victim(i,id,0,unarmed,0)
							}
						}else if(dist < radius3) {
							if (get_user_godmode(id)!=1) {
								do_victim(i,id,0,unarmed,0)
							}
						}
					}
				}
			}
		}
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(3)
		write_coord(vExplodeAt[0])
		write_coord(vExplodeAt[1])
		write_coord(vExplodeAt[2])
		write_short(boom)
		write_byte(100)
		write_byte(15)
		write_byte(0)
		message_end()
		remove_entity(pToucher)
		is_heat_rocket[id] = 0
		is_scan_rocket[id] = 0

		new szClassName1[32]
		if(pTouched > maxplayers)
			get_string(pTouched, szClassName1, 31)
		if(equal(szClassName1, "lud_missile")) {
			remove_task(2020+pTouched)
			emit_sound(pTouched, CHAN_WEAPON, "weapons/explode3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
			emit_sound(pTouched, CHAN_VOICE, "weapons/explode3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			new id2 = entity_get_edict(pTouched, EV_ENT_owner)
			attach_view(id2, id2)
			if(has_rocket[id2] == pTouched){
				has_rocket[id2] = 0
				is_heat_rocket[id2] = 0
				is_scan_rocket[id2] = 0
			}
			remove_entity(pTouched)
		}
	}
	return 1
}

dmessage(victim,attacker,weaponDescription[]){
	message_begin( MSG_BROADCAST, get_user_msgid("DeathMsg"),{0,0,0},0)
	write_byte(attacker)
	write_byte(victim)
	write_byte(0)
	write_string(weaponDescription)
	message_end()
}

do_victim(victim,attacker,damage,unarmed,tk){
	new namek[32],namev[32],authida[40],authidv[40],teama[32],teamv[32]
	get_user_name(victim,namev,31)
	get_user_name(attacker,namek,31)
	get_user_authid(victim,authidv,39)
	get_user_authid(attacker,authida,39)
	get_user_team(victim,teamv,31)
	get_user_team(attacker,teama,31)

	if(unarmed != 1){
		if(damage > 99){
			user_kill(victim,1)
			if(unarmed != 2){
				if(get_cvar_num("mp_logdetail") == 3){
					log_message("^"%s<%d><%s><%s>^" attacked ^"%s<%d><%s><%s>^" with ^"Missile^" (hit ^"head^") (damage ^"%d^") (health ^"0^")",
					namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(victim),authidv,teamv,damage)
				}
				log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"Missile^"",
					namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(victim),authidv,teamv)
				dmessage(victim,attacker,"Missile")
				client_print(attacker,print_chat,"[Copter] You killed %s with that missile",namev)
				client_print(victim,print_chat,"[Copter] You were killed by %s's missile",namek)		
				if(tk == 0){
					set_user_frags(attacker,get_user_frags(attacker) +1 )
					//shAddXP( attacker, victim, 1)
				}else{
					tkcount[attacker] +=1
					client_print(attacker,print_center,"You killed a teammate")
					set_user_frags(attacker,get_user_frags(attacker) -1 )
					//shAddXP( attacker, victim, -1)
				}
			}
		}else{
			set_user_health(victim,get_user_health(victim) - damage )
			if(unarmed != 2){			
				if(get_cvar_num("mp_logdetail") == 3){
					log_message("^"%s<%d><%s><%s>^" attacked ^"%s<%d><%s><%s>^" with ^"Missile^" (hit ^"chest^") (damage ^"%d^") (health ^"%d^")",
					namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(victim),authidv,teamv,damage,get_user_health(victim))
				}
				if(get_user_health(victim) < 1){				
					log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"Missile^"",
						namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(victim),authidv,teamv)
					dmessage(victim,attacker,"Missile")
					client_print(attacker,print_chat,"[Copter] You killed %s with that missile",namev)
					client_print(victim,print_chat,"[Copter] You were killed by %s's missile",namek)
					if(tk == 0){	
						set_user_frags(attacker,get_user_frags(attacker) +1 )
						//shAddXP( attacker, victim, 1)
					}else{
						tkcount[attacker] +=1
						client_print(attacker,print_center,"You killed a teammate")
						set_user_frags(attacker,get_user_frags(attacker) -1 )
						//shAddXP( attacker, victim, -1)
					}
					set_user_frags(victim,get_user_frags(victim) +1 )
				}else{
					client_print(attacker,print_chat,"[Copter] You hurt %s with that missile",namev)
					client_print(victim,print_chat,"[Copter] You were hurt by %s's missile",namek)
				}
			}		
		}
		if(tk == 1 && unarmed == 0){
			new players[32],pNum
			get_players(players,pNum,"e",teama)
			for(new i=0;i<pNum;i++)
				client_print(players[i],print_chat,"%s  attacked a teammate",namek)
			new punish1 = get_cvar_num("Copter_missile_tkpunish1")
			new punish2 = get_cvar_num("Copter_missile_tkpunish2")
			if(punish1 > 2){
				user_kill(attacker,0)
				set_hudmessage(255,50,50, -1.0, 0.45, 0, 0.02, 10.0, 1.01, 1.1, 4)	
				show_hudmessage(attacker,"YOU WERE KILLED^nFOR ATTACKING TEAMMATES.^nSEE THAT IT HAPPENS NO MORE!") 
			}
			if((punish1) && (tkcount[attacker] > punish2 - 1)){
				if(punish1 == 1 || punish1 == 3) 
					client_cmd(attacker,"echo You were kicked for team killing;disconnect")
				else if(punish1 == 2 || punish1 == 4){
					client_cmd(attacker,"echo You were banned for team killing")
					if (equal("4294967295",authida)){
						new ipa[32]
						get_user_ip(attacker,ipa,31,1)
						server_cmd("addip 180.0 %s;writeip",ipa)
					}else{
						server_cmd("banid 180.0 %s kick;writeid",authida)
					}	
				}
			}
		}
	}
}

public fire_missile(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	if(is_user_alive(id) == 0){
		client_print(id,print_chat,"[Copter] You cannot use a missile when you are dead.")
		return PLUGIN_HANDLED
	}
	show_missile_inv(id)
	if(has_rocket[id]){ 
		client_print(id,print_chat,"[Copter] You cannot have more than one missile in the air at a time.")
		return PLUGIN_HANDLED
	}

	new cmd[32],icmd
	read_argv(0,cmd,31)
	if(equal(cmd,"Copter_guncamera_missile"))
		icmd = 1		
	else if(equal(cmd,"Copter_laserguided_missile"))
		icmd = 2
	else if(equal(cmd,"Copter_heatseeking_missile"))
		icmd = 3
	else if(equal(cmd,"Copter_missile"))
		icmd = 4
	else if(equal(cmd,"Copter_ropeseeking_missile"))
		icmd = 6
	else if(equal(cmd,"Copter_swirlingdeath_missile"))
		icmd = 7
	else 
		icmd = 5
	if(icmd == 5){
		if(radar_batt[id] < 1){
			client_print(id,print_chat,"[Copter] Your anti-missile radar batteries are dead.")
			return PLUGIN_HANDLED
		}
		if(is_scan_rocket[id] == 1) {
			remove_task(35632+id)
			is_scan_rocket[id] = 0
			missile_inv[id][icmd] += 1
			set_hudmessage(0,255,0, -1.0, 0.30, 0, 0.02, 3.0, 1.01, 1.1, 4)	
			show_hudmessage(id,"ANTIMISSILE RADAR DEACTIVATED")
			return PLUGIN_HANDLED
		}
	} 
	if( (icmd == 1 || icmd == 7) && (round_st == 1) && (get_cvar_num("Copter_missile_atspawn") == 0) ){
		client_print(id,print_chat,"[Copter] This missile type cannot be fired until 15 seconds after round start.")
		return PLUGIN_HANDLED
	}
	if(get_cvar_num("Copter_missile_buy") == 1){
		new cvarname[32]
		format(cvarname,31,"Copter_missile_cost%d",icmd)
		new umoney = cs_get_user_money(id)
		new m_cost = get_cvar_num(cvarname)
		if(umoney < m_cost){
			client_print(id,print_chat,"[Copter]  Insufficient funds.  Each of these missiles costs %d money",m_cost)
			return PLUGIN_HANDLED
		}else{
			cs_set_user_money(id,umoney-m_cost,1)
		}
	}else{
		new pass
		if( (icmd == 7) && (get_cvar_num("Copter_missile_ammo7takeall") == 1) ){
			pass = 1
			new sum
			for(new i=1;i<8;i++)
				sum += missile_inv[id][i]
			if(sum < 7){				
				client_print(id,print_chat,"[Copter] You do not have enough missiles to make a swirling death missile.")
				return PLUGIN_HANDLED
			}else{
				new take
				for(new b=1;b<8;b++){
					if(take < 7){
						for(new i=1;i<8;i++){
							if( (missile_inv[id][i] > 0) && (take < 7) ){ 				
								missile_inv[id][i] -= 1
								take +=1
							}
						}
					}
				}
			}		
		}
		if( (!pass) && (missile_inv[id][icmd] < 1) ){
			switch(icmd){
				case 1: client_print(id,print_chat,"[Copter] You have no more guncamera missiles.")
				case 2: client_print(id,print_chat,"[Copter] You have no more laserguided missiles.")
				case 3: client_print(id,print_chat,"[Copter] You have no more heatseeking missiles.")
				case 4: client_print(id,print_chat,"[Copter] You have no more stupid missiles.")
				case 5: client_print(id,print_chat,"[Copter] You have no more anti-missile missiles.")
				case 6: client_print(id,print_chat,"[Copter] You have no more ropeseeking missiles.")
				case 7: client_print(id,print_chat,"[Copter] You have no more swirling death missiles.")
			}
			return PLUGIN_HANDLED
		}else{
			missile_inv[id][icmd] -= 1
		}
	}
	if(icmd != 5){
		show_missile_inv(id)
		if(icmd == 6)
			make_rocket(id,icmd,get_cvar_num("Copter_missile_rsspeed"),0,1,0,0)
		else if(icmd == 7)
			make_rocket(id,icmd,get_cvar_num("Copter_missile_sdspeed"),0,1,0,0)
		else if(icmd == 3)
			make_rocket(id,icmd,get_cvar_num("Copter_missile_hsspeed"),0,1,0,0)
		else
			make_rocket(id,icmd,get_cvar_num("Copter_missile_speed"),0,1,0,0)
	}else{
		is_scan_rocket[id] = 1
		new args[2]
		args[0] = id
		set_task(0.2,"anti_missile_radar",35632+id,args,2,"b")
		set_task(0.3,"amr_pay",35632+id,args,2,"b")
		set_hudmessage(0,255,0, -1.0, 0.30, 0, 0.02, 3.0, 1.01, 1.1, 4)	
		show_hudmessage(id,"ANTIMISSILE:^nRADAR SYSTEM ACTIVATED^n(aim at missile you want to shoot down)")
	}
	return PLUGIN_HANDLED
}

public anti_missile_radar(args[]){
	new maxplayers = get_maxplayers()+1
	new id = args[0]
	new tid = 0
	new aimvec[3],origin[3],length
	new radarvec1[3],radarvec2[3],radarvec3[3],radarvec4[3],radarvec5[3]
	get_user_origin(id,origin)
	get_user_origin(id,aimvec,3)
	radarvec1[0]=aimvec[0]-origin[0]
	radarvec1[1]=aimvec[1]-origin[1]
	radarvec1[2]=aimvec[2]-origin[2] 
	length=sqrt(radarvec1[0]*radarvec1[0]+radarvec1[1]*radarvec1[1]+radarvec1[2]*radarvec1[2]) 
	radarvec5[0]=radarvec1[0]*1750/length + origin[0]
	radarvec5[1]=radarvec1[1]*1750/length + origin[1]
	radarvec5[2]=radarvec1[2]*1750/length + origin[2]
	radarvec4[0]=radarvec1[0]*1350/length + origin[0]
	radarvec4[1]=radarvec1[1]*1350/length + origin[1]
	radarvec4[2]=radarvec1[2]*1350/length + origin[2]
	radarvec3[0]=radarvec1[0]*950/length + origin[0]
	radarvec3[1]=radarvec1[1]*950/length + origin[1]
	radarvec3[2]=radarvec1[2]*950/length + origin[2]
	radarvec2[0]=radarvec1[0]*700/length + origin[0]
	radarvec2[1]=radarvec1[1]*700/length + origin[1]
	radarvec2[2]=radarvec1[2]*700/length + origin[2]
	radarvec1[0]=radarvec1[0]*350/length + origin[0]
	radarvec1[1]=radarvec1[1]*350/length + origin[1]
	radarvec1[2]=radarvec1[2]*350/length + origin[2]

	for(new i=1; i<=maxplayers; i++) {
		if( (has_rocket[i] > maxplayers) && (i != id) && (tid < maxplayers) ){
			new szClassName[32]
			get_string(has_rocket[i], szClassName, 31)
			if(equal(szClassName, "lud_missile")){
				new rocketvec[3]
				new Float:fl_rocketvec[3]
				entity_get_vector(has_rocket[i], EV_VEC_origin, fl_rocketvec)
				rocketvec[0] = floatround(fl_rocketvec[0])
				rocketvec[1] = floatround(fl_rocketvec[1])
				rocketvec[2] = floatround(fl_rocketvec[2])
				if(get_distance(radarvec5,rocketvec) < 100)
					tid = has_rocket[i]
				else if(get_distance(radarvec4,rocketvec) < 100)
					tid = has_rocket[i]
				else if(get_distance(radarvec3,rocketvec) < 85)
					tid = has_rocket[i]
				else if(get_distance(radarvec2,rocketvec) < 70)
					tid = has_rocket[i]
				else if(get_distance(radarvec1,rocketvec) < 50)
					tid = has_rocket[i]
			}
		}
	}
	if(tid > maxplayers){
		client_cmd(id,"spk fvox/beep")
		set_hudmessage(255,0,0, -1.0, 0.30, 0, 0.02, 3.0, 1.01, 1.1, 4)	
		show_hudmessage(id,"ANTIMISSILE LOCKED ONTO TARGET")
		is_scan_rocket[id] = 0
		remove_task(35632+id)
		make_rocket(id,5,get_cvar_num("Copter_missile_speed")*5,0,1,0,tid)
	}
	return PLUGIN_CONTINUE
}

public amr_pay(args[]){
	new id = args[0]
	set_hudmessage(255,0,0, -1.0, 0.30, 0, 0.02, 3.0, 1.01, 1.1, 4)
	if(radar_batt[id] < 1){
		show_hudmessage(id,"WARNING: ANTIMISSILE RADAR SYSTEM FAILURE")
		client_print(id,print_center,"^n^nBattery is dead")	
		is_scan_rocket[id] = 0
		remove_task(35632+id)
	}else{
		client_print(id,print_center,"^n^n^nBattery %d",radar_batt[id])
	}
	radar_batt[id] -= 1
	client_cmd(id,"spk fvox/blip")
	return PLUGIN_CONTINUE
}

make_rocket(id,icmd,iarg1,iarg2,iarg3,admin,antimissile){ 
	/* userindex,commandtype,missilespeed,chickenornot,nofake,admincommand,antimissleid */
	new args[16]
	new Float:vOrigin[3]
	new Float:vAngles[3]
	entity_get_vector(id, EV_VEC_origin, vOrigin)
	entity_get_vector(id, EV_VEC_v_angle, vAngles)
	new notFloat_vOrigin[3]
	notFloat_vOrigin[0] = floatround(vOrigin[0])
	notFloat_vOrigin[1] = floatround(vOrigin[1])
	notFloat_vOrigin[2] = floatround(vOrigin[2])

	if(icmd == 3){
		new aimvec[3]
		get_user_origin(id,aimvec,3)
		new dist = get_distance(notFloat_vOrigin,aimvec)
		new found
		new dist1 = 20000

		new players[32], inum
		get_players(players,inum,"a")
		for(new i = 0 ;i < inum ;++i){
			if(players[i] != id){
				new soutput[8],output 
				get_user_info(players[i],"JETPACK_RUN",soutput,7)
				output = str_to_num(soutput)
				if(cmd_jetpackrun[players[i]] == 1)
					output = 1
				if(output){
					new temp[3]
					get_user_origin(players[i],temp)
					dist1 = get_distance(temp,aimvec)
					if(dist1 < dist){
						dist = dist1
						found = 1
						args[6] = players[i]
					}
				}
			}
		}
		if(!found){
			client_print(id,print_chat,"[Copter]  Cannot fire heat seeking missile, no running jetpacks in view.")
			if(!admin){
				if(get_cvar_num("Copter_missile_buy") == 1){
					new umoney = cs_get_user_money(id)
					new m_cost = get_cvar_num("Copter_missile_cost3")
					cs_set_user_money(id,umoney+m_cost,1)
				}else{
					missile_inv[id][3] += 1
					show_missile_inv(id)
				}
				if(using_menu[id] == 1)
					show_main_menu(id)
			}
			return PLUGIN_HANDLED			
		}
	}
	else if(icmd == 6){
		new aimvec[3]
		get_user_origin(id,aimvec,3)
		new dist = get_distance(notFloat_vOrigin,aimvec)
		new found
		new dist1 = 20000
		new players[32], inum
		get_players(players,inum,"a")
		for(new i = 0 ;i < inum ;++i){
			if(players[i] != id){
				if(cmd_onrope[players[i]] == 1){
					new temp[3]
					get_user_origin(players[i],temp)
					dist1 = get_distance(temp,aimvec)
					if(dist1 < dist){
						dist = dist1
						found = 1
						args[6] = players[i]
					}
				}
			}
		}
		if(!found){
			client_print(id,print_chat,"[Copter]  Cannot fire rope seeking missile, no ropes in view.")
			if(!admin){
				if(get_cvar_num("Copter_missile_buy") == 1){
					new umoney = cs_get_user_money(id)
					new m_cost = get_cvar_num("Copter_missile_cost6")
					cs_set_user_money(id,umoney+m_cost,1)
				}else{
					missile_inv[id][6] += 1
					show_missile_inv(id)
				}
				if(using_menu[id] == 1)
					show_main_menu(id)
			}
			return PLUGIN_HANDLED			
		}
	}
	using_menu[id] = 0

	new NewEnt
	NewEnt = create_entity("info_target")
	if(NewEnt == 0) {
		client_print(id,print_chat,"Rocket failure")
		return PLUGIN_HANDLED_MAIN
	}
	has_rocket[id] = NewEnt
	if(admin == 1){
		if(iarg3 == 1)
			missile_inv[id][0] = 2
		else
			missile_inv[id][0] = 1
	}else{
		missile_inv[id][0] = 0
	}
	entity_set_string(NewEnt, EV_SZ_classname, "lud_missile")
	if(!iarg2) entity_set_model(NewEnt, "models/rpgrocket.mdl") 
	else return PLUGIN_CONTINUE

	new Float:fl_vecmins[3] = {-1.0, -1.0, -1.0}
	new Float:fl_vecmaxs[3] = {1.0, 1.0, 1.0}

	entity_set_vector(NewEnt, EV_VEC_mins,fl_vecmins)
	entity_set_vector(NewEnt, EV_VEC_maxs,fl_vecmaxs)

	entity_set_origin(NewEnt, vOrigin)
	entity_set_vector(NewEnt, EV_VEC_angles, vAngles)

	if(!iarg2)
		entity_set_int(NewEnt, EV_INT_effects, 64)  
	else
		entity_set_int(NewEnt, EV_INT_effects, 2)  
	entity_set_int(NewEnt, EV_INT_solid, 2)    
	if(get_cvar_num("Copter_missile_obeygravity"))
		entity_set_int(NewEnt, EV_INT_movetype, 6) 
	else
		entity_set_int(NewEnt, EV_INT_movetype, 5) 
	entity_set_edict(NewEnt, EV_ENT_owner, id)
	entity_set_float(NewEnt, EV_FL_health, 10000.0)
	entity_set_float(NewEnt, EV_FL_takedamage, 100.0)
	entity_set_float(NewEnt, EV_FL_dmg_take, 100.0)
	
	new Float:fl_iNewVelocity[3]
	new iNewVelocity[3]
	VelocityByAim(id, iarg1, fl_iNewVelocity)
	entity_set_vector(NewEnt, EV_VEC_velocity, fl_iNewVelocity)
	iNewVelocity[0] = floatround(fl_iNewVelocity[0]) 
	iNewVelocity[1] = floatround(fl_iNewVelocity[1]) 
	iNewVelocity[2] = floatround(fl_iNewVelocity[2]) 

	emit_sound(NewEnt, CHAN_WEAPON, "weapons/rocketfire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	emit_sound(NewEnt, CHAN_VOICE, "weapons/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	args[0] = id
	args[1] = NewEnt
	args[2] = iarg1
	args[3] = iNewVelocity[0]
	args[4] = iNewVelocity[1]
	args[5] = iNewVelocity[2]
	args[8] = notFloat_vOrigin[0]
	args[9] = notFloat_vOrigin[1]
	args[10] = notFloat_vOrigin[2]

	switch(icmd){
		case 1: {
			make_trail(NewEnt,icmd)
			entity_set_float(NewEnt, EV_FL_gravity, 0.25)
			entity_set_int(NewEnt, EV_INT_rendermode,1) 
			attach_view(id, NewEnt)
			args[11] = 1
			set_task(0.1,"guide_rocket_dir",2020+NewEnt,args,16,"b")
			set_task(get_cvar_float("Copter_missile_fuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		case 2: {
			make_trail(NewEnt,icmd) 
			entity_set_float(NewEnt, EV_FL_gravity, 0.25)
			set_task(0.1,"guide_rocket_las",2020+NewEnt,args,16)
			set_task(get_cvar_float("Copter_missile_fuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		case 3: {
			is_heat_rocket[id] = 1
			make_trail(NewEnt,icmd)
			entity_set_float(NewEnt, EV_FL_gravity, 0.25)
			set_task(0.1,"guide_rocket_het",2020+NewEnt,args,16)
			set_task(get_cvar_float("Copter_missile_fuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		case 4: {
			make_trail(NewEnt,icmd)
			entity_set_float(NewEnt, EV_FL_gravity, 0.25)
			set_task(0.1,"guide_rocket_comm",2020+NewEnt,args,16,"b")
			set_task(get_cvar_float("Copter_missile_fuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		case 5: {
			make_trail(NewEnt,icmd)
			args[6] = antimissile
			entity_set_float(NewEnt, EV_FL_gravity, 0.25)
			set_task(0.1,"guide_rocket_anti",2020+NewEnt,args,16)
			set_task(get_cvar_float("Copter_missile_fuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		case 6: {
			make_trail(NewEnt,icmd)
			entity_set_float(NewEnt, EV_FL_gravity, 0.25)
			set_task(0.1,"guide_rocket_rope",2020+NewEnt,args,16)
			set_task(get_cvar_float("Copter_missile_fuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		#if use_cmath == 1
		case 7: {
			entity_set_float(NewEnt, EV_FL_gravity, 0.000001)
			SD_CircleRockets(NewEnt) 
			set_task(0.1,"guide_rocket_swirl",2020+NewEnt,args,16)
			set_task(get_cvar_float("Copter_missile_sdfuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
		}
		#endif
	}
	return PLUGIN_HANDLED_MAIN
}

make_trail(NewEnt,style){
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(22) 
	write_short(NewEnt) 
	write_short(beam) 
	write_byte(45) 
	write_byte(4)
	switch(style){
		case 3: { 
			write_byte(250) 
			write_byte(100) 
			write_byte(100)
			write_byte(100) 
		}
		case 6: {
			write_byte(100) 
			write_byte(250) 
			write_byte(100)
			write_byte(100) 
		}
		case 7: {
			write_byte(100) 
			write_byte(100) 
			write_byte(250)
			write_byte(100) 
		}

		default: {
			write_byte(250) 
			write_byte(250) 
			write_byte(250)
			write_byte(100)
		}
	} 
	message_end() 
}

public guide_rocket_comm(args[]){
	new ent = args[1]
	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)

	return PLUGIN_CONTINUE
}

public guide_rocket_dir(args[]){
	new id = args[0]
	new ent = args[1]
	new speed = args[2]
	new Float:fl_iNewVelocity[3] 
	VelocityByAim(id, speed, fl_iNewVelocity)
	entity_set_vector(ent, EV_VEC_velocity, fl_iNewVelocity)

	new Float:vAngles[3]
	entity_get_vector(id, EV_VEC_v_angle, vAngles)
	entity_set_vector(ent, EV_VEC_angles, vAngles)

	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)		
	return PLUGIN_CONTINUE
}

public guide_rocket_las(args[]){
	new aimvec[3],avgFactor
	new Float:fl_origin[3]
	new id = args[0]
	new ent = args[1]
	new speed = args[2]
	get_user_origin(id,aimvec,3)
	make_dot(aimvec)  
	entity_get_vector(ent, EV_VEC_origin, fl_origin)
	new iNewVelocity[3]
	new origin[3]
	origin[0] = floatround(fl_origin[0])
	origin[1] = floatround(fl_origin[1])
	origin[2] = floatround(fl_origin[2])
	if(speed < 400)
		avgFactor = 10
	else if(speed < 850)
		avgFactor = 4
	else
		avgFactor = 2
	new velocityvec[3],length
	velocityvec[0]=aimvec[0]-origin[0] 
	velocityvec[1]=aimvec[1]-origin[1]
	velocityvec[2]=aimvec[2]-origin[2]
	length=sqrt(velocityvec[0]*velocityvec[0]+velocityvec[1]*velocityvec[1]+velocityvec[2]*velocityvec[2])
	velocityvec[0]=velocityvec[0]*speed/length 
	velocityvec[1]=velocityvec[1]*speed/length 
	velocityvec[2]=velocityvec[2]*speed/length 
	iNewVelocity[0] = (velocityvec[0] + (args[3] * (avgFactor-1) ) ) / avgFactor
	iNewVelocity[1] = (velocityvec[1] + (args[4] * (avgFactor-1) ) ) / avgFactor
	iNewVelocity[2] = (velocityvec[2] + (args[5] * (avgFactor-1) ) ) / avgFactor
	new Float:fl_iNewVelocity[3] 
	fl_iNewVelocity[0] = iNewVelocity[0] + 0.0
	fl_iNewVelocity[1] = iNewVelocity[1] + 0.0
	fl_iNewVelocity[2] = iNewVelocity[2] + 0.0
	entity_set_vector(ent, EV_VEC_velocity, fl_iNewVelocity)
	args[3] = iNewVelocity[0]
	args[4] = iNewVelocity[1]
	args[5] = iNewVelocity[2]
	args[8] = origin[0]
	args[9] = origin[1]
	args[10] = origin[2]
	set_task(0.1,"guide_rocket_las",2020+ent,args,16)

	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)	

	return PLUGIN_CONTINUE
}

public guide_rocket_het(args[]){
	new aimvec[3],avgFactor
	new Float:fl_origin[3]
	new t_aimvec[33][3]
	new t_index[33]
	new t_jp,dist
	new jp_dist = 20000
	new id = args[0]
	new ent = args[1]
	new speed = args[2]
	new iNewVelocity[3]
	entity_get_vector(ent, EV_VEC_origin, fl_origin)
	new origin[3]
	origin[0] = floatround(fl_origin[0])
	origin[1] = floatround(fl_origin[1])
	origin[2] = floatround(fl_origin[2])

	new soutput[8],output 
	get_user_info(args[6],"JETPACK_RUN",soutput,7)
	output = str_to_num(soutput)
	if(cmd_jetpackrun[args[6]] == 1)
		output = 1

	if((output == 1) || (args[7] < 5)){
		if(is_user_alive(args[6]) == 1){
			get_user_origin(args[6],aimvec)
			dist = get_distance(aimvec,origin)
		}else{
			args[7] = 100
		}
		if(output == 1)
			args[7] = 0
	}else{
		new players[32], inum
		get_players(players,inum,"a")
		for(new i = 0 ;i < inum ;++i){
			if(players[i] != id){
				setc(soutput,8,0)	
				get_user_info(players[i],"JETPACK_RUN",soutput,7)
				output = str_to_num(soutput)
				if(cmd_jetpackrun[players[i]] == 1)
					output = 1
				if(output){
					new temp[3]
					get_user_origin(players[i],temp)
					t_aimvec[t_jp][0] = temp[0]
					t_aimvec[t_jp][1] = temp[1]
					t_aimvec[t_jp][2] = temp[2]
					t_index[t_jp] = players[i]
					t_jp++
				}
			}
		}
		for(new i = 0 ;i < t_jp ;++i){
			new temp[3]
			temp[0] = t_aimvec[i][0]
			temp[1] = t_aimvec[i][1]
			temp[2] = t_aimvec[i][2]
			dist = get_distance(temp,origin)
			if(dist < jp_dist){
				aimvec[0] = temp[0]
				aimvec[1] = temp[1]
				aimvec[2] = temp[2]
				jp_dist = dist
				args[6] = t_index[i]
				args[7] = 0	
			}
		}	
	}	  
	if(dist){
		if(speed < 400)
			avgFactor = 10
		else if(speed < 850)
			avgFactor = 4
		else
			avgFactor = 2

		new length, velocityvec[3]
		velocityvec[0]=aimvec[0]-origin[0] 
		velocityvec[1]=aimvec[1]-origin[1] 
		velocityvec[2]=aimvec[2]-origin[2] 
		length=sqrt(velocityvec[0]*velocityvec[0]+velocityvec[1]*velocityvec[1]+velocityvec[2]*velocityvec[2]) 
		velocityvec[0]=velocityvec[0]*speed/length 
		velocityvec[1]=velocityvec[1]*speed/length 
		velocityvec[2]=velocityvec[2]*speed/length 

		iNewVelocity[0] = (velocityvec[0] + (args[3] * (avgFactor-1) ) ) / avgFactor
		iNewVelocity[1] = (velocityvec[1] + (args[4] * (avgFactor-1) ) ) / avgFactor
		iNewVelocity[2] = (velocityvec[2] + (args[5] * (avgFactor-1) ) ) / avgFactor

		args[3] = iNewVelocity[0]
		args[4] = iNewVelocity[1]
		args[5] = iNewVelocity[2]
		if(dist < 20){
			vexd_pfntouch(ent,0)
			return PLUGIN_CONTINUE
		}			
	}
	args[7] += 1
	new Float:fl_iNewVelocity[3]
	fl_iNewVelocity[0] = args[3] +0.0
	fl_iNewVelocity[1] = args[4] +0.0
	fl_iNewVelocity[2] = args[5] +0.0

	entity_set_vector(ent, EV_VEC_velocity, fl_iNewVelocity)
	set_task(0.1,"guide_rocket_het",2020+ent,args,16)

	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)	

	return PLUGIN_CONTINUE
}

public guide_rocket_anti(args[]){
	new Float:fl_aimvec[3]
	new Float:fl_origin[3]
	new avgFactor
	new id = args[0]
	new ent = args[1]
	new speed = args[2]
	new iNewVelocity[3]

	entity_get_vector(ent, EV_VEC_origin, fl_origin)
	new origin[3]
	origin[0] = floatround(fl_origin[0])
	origin[1] = floatround(fl_origin[1])
	origin[2] = floatround(fl_origin[2])

	if(find_ent(args[6], "lud_missile") != -1){	
		entity_get_vector(args[6], EV_VEC_origin, fl_aimvec)
	  	new aimvec[3]
		aimvec[0] = floatround(fl_aimvec[0])
		aimvec[1] = floatround(fl_aimvec[1])
		aimvec[2] = floatround(fl_aimvec[2])
		if(speed < 400)
			avgFactor = 10
		else if(speed < 850)
			avgFactor = 4
		else
			avgFactor = 2
		new length, velocityvec[3]
		velocityvec[0]=aimvec[0]-origin[0] 
		velocityvec[1]=aimvec[1]-origin[1] 
		velocityvec[2]=aimvec[2]-origin[2] 
		length=sqrt(velocityvec[0]*velocityvec[0]+velocityvec[1]*velocityvec[1]+velocityvec[2]*velocityvec[2]) 
		velocityvec[0]=velocityvec[0]*speed/length 
		velocityvec[1]=velocityvec[1]*speed/length 
		velocityvec[2]=velocityvec[2]*speed/length 
		iNewVelocity[0] = (velocityvec[0] + (args[3] * (avgFactor-1) ) ) / avgFactor
		iNewVelocity[1] = (velocityvec[1] + (args[4] * (avgFactor-1) ) ) / avgFactor
		iNewVelocity[2] = (velocityvec[2] + (args[5] * (avgFactor-1) ) ) / avgFactor
		args[3] = iNewVelocity[0]
		args[4] = iNewVelocity[1]
		args[5] = iNewVelocity[2]
		if(get_distance(origin,aimvec) < 150){
			vexd_pfntouch(ent,args[6])
			return PLUGIN_CONTINUE
		}			
		new Float:fl_iNewVelocity[3]
		fl_iNewVelocity[0] = args[3] +0.0
		fl_iNewVelocity[1] = args[4] +0.0
		fl_iNewVelocity[2] = args[5] +0.0
		entity_set_vector(ent, EV_VEC_velocity, fl_iNewVelocity)
		set_task(0.1,"guide_rocket_anti",2020+ent,args,16)
	}
	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)	
	client_cmd(id,"spk buttons/blip2")
	return PLUGIN_CONTINUE
}

public guide_rocket_rope(args[]){
	new aimvec[3],avgFactor
	new Float:fl_origin[3]
	new t_aimvec[33][3]
	new t_index[33]
	new t_jp,dist
	new jp_dist = 20000
	new id = args[0]
	new ent = args[1]
	new speed = args[2]
	new iNewVelocity[3]
	entity_get_vector(ent, EV_VEC_origin, fl_origin)
	new origin[3]
	origin[0] = floatround(fl_origin[0])
	origin[1] = floatround(fl_origin[1])
	origin[2] = floatround(fl_origin[2])

	if((cmd_onrope[args[6]] == 1) || (args[7] < 31)){
		if(is_user_alive(args[6]) == 1){
			get_user_origin(args[6],aimvec)
			dist = get_distance(aimvec,origin)
		}else{
			args[7] = 100
		}
		if(cmd_onrope[args[6]] == 1)
			args[7] = 0
	}else{
		new players[32], inum
		get_players(players,inum,"a")
		for(new i = 0 ;i < inum ;++i){
			if(players[i] != id){
				if(cmd_onrope[players[i]] == 1){
					new temp[3]
					get_user_origin(players[i],temp)
					t_aimvec[t_jp][0] = temp[0]
					t_aimvec[t_jp][1] = temp[1]
					t_aimvec[t_jp][2] = temp[2]
					t_index[t_jp] = players[i]
					t_jp++
				}
			}
		}
		for(new i = 0 ;i < t_jp ;++i){
			new temp[3]
			temp[0] = t_aimvec[i][0]
			temp[1] = t_aimvec[i][1]
			temp[2] = t_aimvec[i][2]
			dist = get_distance(temp,origin)
			if(dist < jp_dist){
				aimvec[0] = temp[0]
				aimvec[1] = temp[1]
				aimvec[2] = temp[2]
				jp_dist = dist
				args[6] = t_index[i]
				args[7] = 0	
			}
		}	
	}	  
	if(dist){
		if(speed < 400)
			avgFactor = 10
		else if(speed < 850)
			avgFactor = 4
		else
			avgFactor = 2

		new length, velocityvec[3]
		velocityvec[0]=aimvec[0]-origin[0] 
		velocityvec[1]=aimvec[1]-origin[1] 
		velocityvec[2]=aimvec[2]-origin[2] 
		length=sqrt(velocityvec[0]*velocityvec[0]+velocityvec[1]*velocityvec[1]+velocityvec[2]*velocityvec[2]) 
		velocityvec[0]=velocityvec[0]*speed/length 
		velocityvec[1]=velocityvec[1]*speed/length 
		velocityvec[2]=velocityvec[2]*speed/length 

		iNewVelocity[0] = (velocityvec[0] + (args[3] * (avgFactor-1) ) ) / avgFactor
		iNewVelocity[1] = (velocityvec[1] + (args[4] * (avgFactor-1) ) ) / avgFactor
		iNewVelocity[2] = (velocityvec[2] + (args[5] * (avgFactor-1) ) ) / avgFactor

		args[3] = iNewVelocity[0]
		args[4] = iNewVelocity[1]
		args[5] = iNewVelocity[2]
		if(dist < 60){
			vexd_pfntouch(ent,0)
			return PLUGIN_CONTINUE
		}			
	}
	args[7] += 1
	new Float:fl_iNewVelocity[3]
	fl_iNewVelocity[0] = args[3] +0.0
	fl_iNewVelocity[1] = args[4] +0.0
	fl_iNewVelocity[2] = args[5] +0.0

	entity_set_vector(ent, EV_VEC_velocity, fl_iNewVelocity)
	set_task(0.1,"guide_rocket_rope",2020+ent,args,16)

	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)	

	return PLUGIN_CONTINUE
}

public guide_rocket_swirl(args[]){
	new ent = args[1]
	set_task(0.1,"guide_rocket_swirl",2020+ent,args,16)
	new Float:missile_health
	missile_health = Float:entity_get_float(ent, EV_FL_health) 
	if(missile_health <10000.0)
		vexd_pfntouch(ent,0)

	return PLUGIN_CONTINUE
}

public rocket_fuel_timer(args[]){
	new ent = args[1]
	new id = args[0]
	remove_task(2020+ent)
	entity_set_int(ent, EV_INT_effects, 2)
	entity_set_int(ent, EV_INT_rendermode,0)
	entity_set_float(ent, EV_FL_gravity, 1.0)
	entity_set_int(ent, EV_INT_iuser1, 0) 
	emit_sound(ent, CHAN_WEAPON, "debris/beamstart8.wav", 1.0, ATTN_NORM, 0, PITCH_NORM )
	emit_sound(ent, CHAN_VOICE, "ambience/rocket_steam1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	if(args[11] == 1){
		set_hudmessage(255,0,0,-1.0,0.45, 0, 0.0, 1.5, 0.5, 0.15, 4)
		show_hudmessage(id,"WARNING:^nFUEL TANK EMPTY^nCONTROLS DISENGAGED") 
	}
	set_task(0.1,"guide_rocket_comm",2020+ent,args,16,"b")
	return PLUGIN_CONTINUE
}

make_dot(vec[]){
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)  
	write_byte( 17 ) 
	write_coord(vec[0]) 
	write_coord(vec[1]) 
	write_coord(vec[2])
	write_short( ls_dot ) 
	write_byte( 10 ) 
	write_byte( 255 ) 
	message_end()
}

public ls_missile_ck(){
	new arg[32]
	read_argv(1,arg,31)
	new iarg = str_to_num(arg) 
	if(iarg){
		new szClassName[32]
		get_string(iarg, szClassName, 31)
		if(equal(szClassName, "lud_missile")) {
			new prize = get_cvar_num("Copter_missile_prizes")
			new obey = get_cvar_num("Copter_missile_obeyffcvar")
			new ff = get_cvar_num("mp_friendlyfire")
			new arg2[32],name[32],nameowner[32],Message[192]
			read_argv(2,arg2,31)
			new id = str_to_num(arg2)
			new owner = entity_get_edict(iarg, EV_ENT_owner)
			new Tid = get_user_team(id)
			new Towner = get_user_team(owner)
			get_user_name(id,name,31)
			get_user_name(owner,nameowner,31)
			set_hudmessage(255,0,0, -1.0, 0.23, 0, 0.02, 5.0, 1.01, 1.1, 4)	
			if( (Tid == Towner) && (cstrike_running == true) && ( ((ff == 1 ) && (obey == 0)) || (ff == 0) ) ){
				format(Message,191,"Woohoo!!!!^n%s successfully shot down^n%s's missile with a laser",name,nameowner)
			}else{
				if(prize){
					format(Message,191,"Woohoo!!!!^n%s successfully shot down^n%s's missile with a laser^nand won free missiles!^n%d of each type!!!",name,nameowner,prize)
					client_print(id,print_chat,"[Copter] Congrats on shooting down that missile, you won free missiles")
					missile_win[id] += 1
					missile_inv[id][1] += prize
					missile_inv[id][2] += prize
					missile_inv[id][3] += prize
					missile_inv[id][4] += prize
					missile_inv[id][5] += prize
					missile_inv[id][6] += prize
					missile_inv[id][7] += prize
				}else{
					format(Message,191,"Woohoo!!!!^n%s successfully shot down^n%s's missile with a laser",name,nameowner)
				}
			}
			show_hudmessage(0,Message)
			client_cmd(0,"spk ^"rocket destroyed^"")
			client_cmd(0,"play ambience/lv4.wav")
			vexd_pfntouch(iarg,0)			
		}	
	}
	return PLUGIN_HANDLED
}	

public jp_missile_ck(){
	new sid[4],sstat[4]
	read_argv(1,sid,3)
	read_argv(2,sstat,3)
	new id = str_to_num(sid)

	if(id < 1 || id > 32)
		id = 32
	cmd_jetpackrun[id] = str_to_num(sstat)

//	new authid[32]
//	get_user_name(id,authid,31)
//	log_to_file("admin_logs/JP_DATA","M  id= %s   status= %s   authid= %s",sid,sstat,authid)

	return PLUGIN_CONTINUE
}

public rp_missile_ck(){
	new sid[4],sstat[4]
	read_argv(1,sid,3)
	read_argv(2,sstat,3)
	cmd_onrope[str_to_num(sid)] = str_to_num(sstat)
	return PLUGIN_CONTINUE
}

show_missile_inv(id){
	if(get_cvar_num("Copter_missile_buy") == 0){
		new Message[304]
		set_hudmessage(303,0,0, 0.80, 0.60, 0, 0.02, 6.0, 1.01, 1.1, 4)	
		#if use_cmath == 1
		if(get_cvar_num("Copter_missile_ammo7takeall") == 0){
			format(Message,303,"MISSILE INVENTORY:^n^nCommon missile  ( %d )^nLaser guided missile  ( %d )^n\
				Heat seeking missile  ( %d )^nGun camera missile  ( %d )^nAnti Missile Shots  ( %d )^n\
				Rope seeking missile  ( %d )^nSwirling death missile  ( %d )",missile_inv[id][4],missile_inv[id][2],
				missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6],missile_inv[id][7])
		}else{
			new sum
			for(new i=1;i<8;i++)
				sum += missile_inv[id][i]	
			if(sum < 7){
				format(Message,303,"MISSILE INVENTORY:^n^nCommon missile  ( %d )^nLaser guided missile  ( %d )^n\
					Heat seeking missile  ( %d )^nGun camera missile  ( %d )^nAnti Missile Shots  ( %d )^n\
					Rope seeking missile  ( %d )^nSwirling death missile  ( 0 )",missile_inv[id][4],missile_inv[id][2],
					missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6])
			}else{
				format(Message,303,"MISSILE INVENTORY:^n^nCommon missile  ( %d )^nLaser guided missile  ( %d )^n\
					Heat seeking missile  ( %d )^nGun camera missile  ( %d )^nAnti Missile Shots  ( %d )^n\
					Rope seeking missile  ( %d )^nSwirling death missile  ( %d )",missile_inv[id][4],missile_inv[id][2],
					missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6],missile_inv[id][7])
			}
		}
		#else
		format(Message,303,"MISSILE INVENTORY:^n^nCommon missile  ( %d )^nLaser guided missile  ( %d )^n\
			Heat seeking missile  ( %d )^nGun camera missile  ( %d )^nAnti Missile Shots  ( %d )^nRope seeking missile  ( %d )",
			missile_inv[id][4],missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6])
		#endif
		show_hudmessage(id,Message)
	}
	return PLUGIN_HANDLED
}

public show_main_menu(id){
	new menu_body[320]
	#if use_cmath == 1
	if (cstrike_running){
		if(get_cvar_num("Copter_missile_buy") == 1){
			format(menu_body,319,"\yFire Missile Menu^n\w^n1. Common missile $%d^n2. Laser guided missile $%d^n\
			3. Heat seeking missile $%d^n4. Gun camera missile $%d^n5. Anti Missile Shots $%d^n\
			6. Rope seeking missile $%d^n7. Swirling death missile $%d^n^n0. Exit",
			get_cvar_num("Copter_missile_cost4"),get_cvar_num("Copter_missile_cost2"),get_cvar_num("Copter_missile_cost3"),
			get_cvar_num("Copter_missile_cost1"),get_cvar_num("Copter_missile_cost5"),get_cvar_num("Copter_missile_cost6"),get_cvar_num("Copter_missile_cost7"))
		}else{
			if(get_cvar_num("Copter_missile_ammo7takeall") == 0){
				format(menu_body,319,"\yFire Missile Menu^n\w^n1. Common missile  ( %d )^n2. Laser guided missile  ( %d )^n\
				3. Heat seeking missile  ( %d )^n4. Gun camera missile  ( %d )^n5. Anti Missile Shots  ( %d )^n\
				6. Rope seeking missile  ( %d )^n7. Swirling death missile  ( %d )^n^n0. Exit",missile_inv[id][4],
				missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6],missile_inv[id][7])
			}else{
				new sum
				for(new i=1;i<8;i++)
					sum += missile_inv[id][i]				
				if(sum < 7){
					format(menu_body,319,"\yFire Missile Menu^n\w^n1. Common missile  ( %d )^n2. Laser guided missile  ( %d )^n\
					3. Heat seeking missile  ( %d )^n4. Gun camera missile  ( %d )^n5. Anti Missile Shots  ( %d )^n\
					6. Rope seeking missile  ( %d )^n7. Swirling death missile  ( 0 )^n^n0. Exit",missile_inv[id][4],
					missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6])
				}else{
					format(menu_body,319,"\yFire Missile Menu^n\w^n1. Common missile  ( %d )^n2. Laser guided missile  ( %d )^n\
					3. Heat seeking missile  ( %d )^n4. Gun camera missile  ( %d )^n5. Anti Missile Shots  ( %d )^n\
					6. Rope seeking missile  ( %d )^n7. Swirling death missile  ( %d )^n^n0. Exit",missile_inv[id][4],
					missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6],missile_inv[id][7])
				}
			}
		}
	}else{
		format(menu_body,319,"Fire Missile Menu^n^n1. Common missile  ( %d )^n2. Laser guided missile  ( %d )^n\
		3. Heat seeking missile  ( %d )^n4. Gun camera missile  ( %d )^n5. Anti Missile Shots  ( %d )^n\
		6. Rope seeking missile  ( %d )^n7. Swirling death missile  ( %d )^n^n0. Exit",missile_inv[id][4],
		missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6],missile_inv[id][7])
	}
	new a1,a2,a3,a4,a5,a6,a7,a8, keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)
	a1 = a2 = a3 = a4 = a5 = a6 = a7 = a8 = (cstrike_running ? 'd' : '#' )
	format(menu_body,255,menu_body,a1,a2,a3,a4,a5,a6,a7,a8)
	#else
	if (cstrike_running){
		if(get_cvar_num("Copter_missile_buy") == 1)
			format(menu_body,319,"\yFire Missile Menu^n\w^n1. Common missile $%d^n2. Laser guided missile $%d^n\
			3. Heat seeking missile $%d^n4. Gun camera missile $%d^n5. Anti Missile Shots $%d^n\
			6. Rope seeking missile $%d^n^n0. Exit",
			get_cvar_num("Copter_missile_cost4"),get_cvar_num("Copter_missile_cost2"),get_cvar_num("Copter_missile_cost3"),
			get_cvar_num("Copter_missile_cost1"),get_cvar_num("Copter_missile_cost5"),get_cvar_num("Copter_missile_cost6"))
		else
			format(menu_body,319,"\yFire Missile Menu^n\w^n1. Common missile  ( %d )^n2. Laser guided missile  ( %d )^n\
			3. Heat seeking missile  ( %d )^n4. Gun camera missile  ( %d )^n5. Anti Missile Shots  ( %d )^n\
			6. Rope seeking missile  ( %d )^n^n0. Exit",missile_inv[id][4],
			missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6])
	}else{
		format(menu_body,319,"Fire Missile Menu^n^n1. Common missile  ( %d )^n2. Laser guided missile  ( %d )^n\
		3. Heat seeking missile  ( %d )^n4. Gun camera missile  ( %d )^n5. Anti Missile Shots  ( %d )^n\
		6. Rope seeking missile  ( %d )^n^n0. Exit",missile_inv[id][4],
		missile_inv[id][2],missile_inv[id][3],missile_inv[id][1],missile_inv[id][5],missile_inv[id][6])
	}
	new a1,a2,a3,a4,a5,a6,a7, keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<9)
	a1 = a2 = a3 = a4 = a5 = a6 = a7 = (cstrike_running ? 'd' : '#' )
	format(menu_body,319,menu_body,a1,a2,a3,a4,a5,a6,a7)
	#endif
	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public action_main_menu(id,key){
	using_menu[id] = 1
	switch(key){
		case 0: {
			client_cmd(id,"Copter_missile")
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost4"))
 	 				show_main_menu(id)
			}else{
				if(missile_inv[id][4] < 1)
					show_main_menu(id)
			}
		}
		case 1: {
			client_cmd(id,"Copter_laserguided_missile")
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost2"))
 	 				show_main_menu(id)
			}else{
				if(missile_inv[id][2] < 1)
					show_main_menu(id)
			}
		}  
		case 2: {
			client_cmd(id,"Copter_heatseeking_missile") 
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost3"))
 	 				show_main_menu(id)
			}else{
				if(missile_inv[id][3] < 1)
					show_main_menu(id)
			}
		} 
		case 3: {
			client_cmd(id,"Copter_guncamera_missile")
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost1"))
 	 				show_main_menu(id)
			}else{
				if(missile_inv[id][1] < 1)
					show_main_menu(id)
			}
		}
		case 4: {
			client_cmd(id,"Copter_anti_missile")
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost5"))
 	 				show_main_menu(id)
			}else{
				if( (missile_inv[id][5] < 1) || (radar_batt[id] < 1) )
					show_main_menu(id)
			}
		}
		case 5: {
			client_cmd(id,"Copter_ropeseeking_missile")
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost6"))
 	 				show_main_menu(id)
			}else{
				if(missile_inv[id][6] < 1)
					show_main_menu(id)
			}
		}
		case 6: {
			client_cmd(id,"Copter_swirlingdeath_missile")
			if(get_cvar_num("Copter_missile_buy") == 1){
				if(cs_get_user_money(id) < get_cvar_num("Copter_missile_cost7"))
 	 				show_main_menu(id)
			}else{
				if(missile_inv[id][7] < 1)
					show_main_menu(id)
			}
		}
		case 9: using_menu[id] = 0
	}
	return PLUGIN_HANDLED
}

public round_end(){
	if(DoOnce == 0){
		DoOnce = 1
		new maxplayers = get_maxplayers()+1
		for (new i=1; i<=maxplayers; i++) {
			if(is_user_connected(i) == 1){
				if( (is_user_alive(i) == 0) && (get_cvar_num("Copter_missile_buy") == 1) ){
					missile_inv[i][1] = 0
					missile_inv[i][2] = 0
					missile_inv[i][3] = 0
					missile_inv[i][4] = 0
					missile_inv[i][5] = 0
					missile_inv[i][6] = 0
					missile_inv[i][7] = 0
				}
			}
			if(has_rocket[i] > 0)
				remove_missile(i,has_rocket[i])
		}
		round_st = 1
		set_task(20.0,"roundstart_delay")
	}
	return PLUGIN_CONTINUE
}

public plugin_log(){
	new args = read_logargc()
	if(args == 2){
		new msg[32]
		read_logargv(1,msg,31)
		if(msg[6] == 'S')
			round_start()
	} 		
	return PLUGIN_CONTINUE
}

public round_start(){
	DoOnce = 0
	new prize = get_cvar_num("Copter_missile_prizes")
	new maxplayers = get_maxplayers()+1
	for (new i=1; i<=maxplayers; i++) {
		radar_batt[i] = get_cvar_num("Copter_missile_radarbattery")
		if(get_cvar_num("Copter_missile_buy") == 0){
			missile_inv[i][1] = get_cvar_num("Copter_missile_ammo1")
			missile_inv[i][2] = get_cvar_num("Copter_missile_ammo2")
			missile_inv[i][3] = get_cvar_num("Copter_missile_ammo3")
			missile_inv[i][4] = get_cvar_num("Copter_missile_ammo4")
			missile_inv[i][5] = get_cvar_num("Copter_missile_ammo5")
			missile_inv[i][6] = get_cvar_num("Copter_missile_ammo6")
			missile_inv[i][7] = get_cvar_num("Copter_missile_ammo7")
		}
		if(missile_win[i] > 0){
			missile_inv[i][1] += (prize * missile_win[i])
			missile_inv[i][2] += (prize * missile_win[i]) 
			missile_inv[i][3] += (prize * missile_win[i])
			missile_inv[i][4] += (prize * missile_win[i])
			missile_inv[i][5] += (prize * missile_win[i])
			missile_inv[i][6] += (prize * missile_win[i])
			missile_inv[i][7] += (prize * missile_win[i])
			missile_win[i] = 0
			client_print(i,print_chat,"[Copter] You won extra missiles from shooting down missile last round")
		}
	}
	new iCurrent = find_ent(-1, "lud_missile") 
	while ((iCurrent = find_ent(-1, "lud_missile")) != -1){ 
		new id = entity_get_edict(iCurrent, EV_ENT_owner)		
		remove_missile(id,iCurrent)
	}		
	return PLUGIN_CONTINUE
}

public roundstart_delay(){
	round_st = 0
}

remove_missile(id,missile){
	new Float:fl_origin[3]
	entity_get_vector(missile, EV_VEC_origin, fl_origin)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(14) 
	write_coord(floatround(fl_origin[0])) 
	write_coord(floatround(fl_origin[1])) 
	write_coord(floatround(fl_origin[2]))  
	write_byte (200) 
	write_byte (40) 
	write_byte (45) 
	message_end()

	emit_sound(missile, CHAN_WEAPON, "ambience/particle_suck2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
	emit_sound(missile, CHAN_VOICE, "ambience/particle_suck2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)		
	has_rocket[id] = 0
	is_heat_rocket[id] = 0
	is_scan_rocket[id] = 0
	remove_task(2020+missile)
	attach_view(id, id)
	remove_entity(missile)
}

#if use_cmath == 1
public SD_CircleRockets(Ent){ 
	new NUMBER_OF_ROCKETS = get_cvar_num("Copter_missile_sdcount")
	new ROCKET_RADIUS =  get_cvar_num("Copter_missile_sdradius")
	new Float:vOrigin[3] 
	new Float:vVelocity[3] 
	new Float:vEntOrig[3] 
	new Float:RotMatrix[3][3] 
	new Float:x, Float:y, Float:z, Float:theta 
	new i, id, NewEnt 
	entity_get_vector(Ent, EV_VEC_origin, vOrigin) 
	entity_get_vector(Ent, EV_VEC_velocity, vVelocity) 
	id = Entvars_Get_Edict(Ent, EV_ENT_owner) 

	RotMatrix[0][0]=vVelocity[0] 
	RotMatrix[0][1]=vVelocity[1] 
	RotMatrix[0][2]=vVelocity[2] 
	RotMatrix[1][0]=-vVelocity[1] 
	RotMatrix[1][1]=vVelocity[0] 
	RotMatrix[1][2]=0.0 
	SD_Normalise(RotMatrix[0]) 
	SD_Normalise(RotMatrix[1]) 

	RotMatrix[2][0]=((RotMatrix[0][1])*(RotMatrix[1][2]))-((RotMatrix[0][2])*(RotMatrix[1][1])) 
	RotMatrix[2][1]=((RotMatrix[0][2])*(RotMatrix[1][0]))-((RotMatrix[0][0])*(RotMatrix[1][2])) 
	RotMatrix[2][2]=((RotMatrix[0][0])*(RotMatrix[1][1]))-((RotMatrix[0][1])*(RotMatrix[1][0])) 

	for (i=0; i<NUMBER_OF_ROCKETS; i++){ 
		theta = (float(i)/float(NUMBER_OF_ROCKETS))*2*PI+fAngle 
		x = 0.0 
		y = cos(theta)*ROCKET_RADIUS 
		z = sin(theta)*ROCKET_RADIUS 

		vEntOrig[0]=RotMatrix[0][0]*x+RotMatrix[1][0]*y+RotMatrix[2][0]*z 
		vEntOrig[1]=RotMatrix[0][1]*x+RotMatrix[1][1]*y+RotMatrix[2][1]*z 
		vEntOrig[2]=RotMatrix[0][2]*x+RotMatrix[1][2]*y+RotMatrix[2][2]*z 
		vEntOrig[0]+=vOrigin[0] 
		vEntOrig[1]+=vOrigin[1] 
		vEntOrig[2]+=vOrigin[2] 
		NewEnt = SD_CreateRocket(vEntOrig, vVelocity, id) 
		entity_set_int(NewEnt, EV_INT_iuser1, Ent) 
		entity_set_int(NewEnt, EV_INT_iuser2, i) 
	} 
} 

public SD_CreateRocket(Float:vOrigin[3], Float:vVelocity[3], id) { 
	new Float:vAngles[3] 
	VecToAngles(vVelocity, vAngles) 
	new NewEnt 
	NewEnt = CreateEntity("info_target") 
	if(NewEnt == 0)
		return 0 
	Entvars_Set_String(NewEnt, EV_SZ_classname, "lud_missile") 
	ENT_SetModel(NewEnt, "models/rpgrocket.mdl") 
	new Float:fl_vecmins[3] = {-1.0, -1.0, -1.0}
	new Float:fl_vecmaxs[3] = {1.0, 1.0, 1.0}
	entity_set_vector(NewEnt, EV_VEC_mins, fl_vecmins) 
	entity_set_vector(NewEnt, EV_VEC_maxs, fl_vecmaxs) 
	entity_set_origin(NewEnt, vOrigin) 
	entity_set_vector(NewEnt, EV_VEC_angles, vAngles) 
	entity_set_int(NewEnt, EV_INT_solid, 2)   
	entity_set_int(NewEnt, EV_INT_movetype, 6)  
	entity_set_edict(NewEnt, EV_ENT_owner, id) 
	entity_set_float(NewEnt, EV_FL_health, 10000.0)
	entity_set_float(NewEnt, EV_FL_takedamage, 100.0)
	entity_set_float(NewEnt, EV_FL_dmg_take, 100.0)
	entity_set_vector(NewEnt, EV_VEC_velocity, vVelocity) 
	make_trail(NewEnt,7) // 7 = swirling missiles
	entity_set_float(NewEnt, EV_FL_gravity, 0.000001 )

	emit_sound(NewEnt, CHAN_WEAPON, "weapons/rocketfire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
	emit_sound(NewEnt, CHAN_VOICE, "weapons/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	new args[16]
	args[0] = id
	args[1] = NewEnt
	args[2] = get_cvar_num("Copter_missile_sdspeed")
	args[3] = floatround(vVelocity[0])
	args[4] = floatround(vVelocity[1])
	args[5] = floatround(vVelocity[2])
	set_task(get_cvar_float("Copter_missile_sdfuel"),"rocket_fuel_timer",2020+NewEnt,args,16)
	return NewEnt 
} 

public SD_Normalise(Float:Vector[3]){ 
	new Float:NullVector[3] = {0.0,0.0,0.0} 
	new Float:fLength = VecDist(Vector, NullVector) 
	Vector[0] /= fLength 
	Vector[1] /= fLength 
	Vector[2] /= fLength 
} 

public RocketThink() {
	new NUMBER_OF_ROCKETS = get_cvar_num("Copter_missile_sdcount") 
	new ANGULAR_VELOCITY = get_cvar_num("Copter_missile_sdrotate")
	new ROCKET_RADIUS =  get_cvar_num("Copter_missile_sdradius") 
	new iCurrent, iCenterRocket, i 
	new Float:vOrigin[3], Float:vVelocity[3] 
	new Float:RotMatrix[3][3] 
	new Float:vEntOrig[3], Float:vOldEntOrig[3] 
	new Float:x, Float:y, Float:z, Float:theta 
	new Float:vAngles[3], Float:fNewVelocity[3] 
	new iTempEnt 
	new bool:bFound 
	fAngle += ANGULAR_VELOCITY * DT 

	if (fAngle>2*PI)
		fAngle -= 2*PI 

	iCurrent = find_ent(-1, "lud_missile") 

	while (iCurrent != -1){ 
		iCenterRocket = Entvars_Get_Int(iCurrent, EV_INT_iuser1) 
		if (iCenterRocket){ 
			bFound = false 
			iTempEnt = -1 
			do{ 
				iTempEnt = find_ent(iTempEnt, "lud_missile") 
				if (iTempEnt == iCenterRocket)
					bFound = true 
			}while (iTempEnt != -1 && !bFound)
			iTempEnt = -1
			do{ 
				iTempEnt = find_ent(iTempEnt, "vexd_vrocket") 
				if (iTempEnt == iCenterRocket) 
					bFound = true 
			}while (iTempEnt != -1 && !bFound) 
			if (bFound){ 
				entity_get_vector(iCenterRocket, EV_VEC_origin, vOrigin) 
				entity_get_vector(iCenterRocket, EV_VEC_velocity, vVelocity) 
				entity_get_vector(iCurrent, EV_VEC_origin, vOldEntOrig) 
				i = Entvars_Get_Int(iCurrent, EV_INT_iuser2) 
				RotMatrix[0][0]=vVelocity[0] 
				RotMatrix[0][1]=vVelocity[1] 
				RotMatrix[0][2]=vVelocity[2] 
				RotMatrix[1][0]=-vVelocity[1] 
				RotMatrix[1][1]=vVelocity[0] 
				RotMatrix[1][2]=0.0 
				SD_Normalise(RotMatrix[0]) 
				SD_Normalise(RotMatrix[1]) 
				RotMatrix[2][0]=((RotMatrix[0][1])*(RotMatrix[1][2]))-((RotMatrix[0][2])*(RotMatrix[1][1])) 
				RotMatrix[2][1]=((RotMatrix[0][2])*(RotMatrix[1][0]))-((RotMatrix[0][0])*(RotMatrix[1][2])) 
				RotMatrix[2][2]=((RotMatrix[0][0])*(RotMatrix[1][1]))-((RotMatrix[0][1])*(RotMatrix[1][0])) 
				theta = (float(i)/float(NUMBER_OF_ROCKETS))*2*PI+fAngle 
				x = 0.0 
				y = cos(theta)*ROCKET_RADIUS 
				z = sin(theta)*ROCKET_RADIUS 
				vEntOrig[0]=RotMatrix[0][0]*x+RotMatrix[1][0]*y+RotMatrix[2][0]*z 
				vEntOrig[1]=RotMatrix[0][1]*x+RotMatrix[1][1]*y+RotMatrix[2][1]*z 
				vEntOrig[2]=RotMatrix[0][2]*x+RotMatrix[1][2]*y+RotMatrix[2][2]*z 
				vEntOrig[0]+=vOrigin[0] 
				vEntOrig[1]+=vOrigin[1] 
				vEntOrig[2]+=vOrigin[2] 
				vEntOrig[0]+=vVelocity[0]*DT 
				vEntOrig[1]+=vVelocity[1]*DT 
				vEntOrig[2]+=vVelocity[2]*DT 
				CalculateVelocity(vOldEntOrig, vEntOrig, fNewVelocity) 
				entity_set_vector(iCurrent, EV_VEC_velocity, fNewVelocity) 
				VecToAngles(fNewVelocity, vAngles) 
				entity_set_vector(iCurrent, EV_VEC_angles, vAngles)
				new Float:missile_health
				missile_health = Float:entity_get_float(iCurrent, EV_FL_health) 
				if(missile_health <10000.0)
					vexd_pfntouch(iCurrent,0)  
			}else{ 
				entity_set_int(iCurrent, EV_INT_iuser1, 0) 
			} 
		} 
		iCurrent =  find_ent(iCurrent, "lud_missile") 
	} 
} 

public CalculateVelocity(Float:vOrigin[3], Float:vEnd[3], Float:vVelocity[3]){ 
	vVelocity[0] = (vEnd[0] - vOrigin[0]) / DT 
	vVelocity[1] = (vEnd[1] - vOrigin[1]) / DT 
	vVelocity[2] = (vEnd[2] - vOrigin[2]) / DT 
}
#endif
//----------------------------------------------------------------------------------------------

public Copter_morph(id)
{

  cs_set_user_model(id,"Copter") 
  g_morphed[id]=true
  // Message
  set_hudmessage(200, 200, 0, 0.35, 0.45, 2, 0.02, 2.0, 0.01, 0.1, 2) 
  show_hudmessage(id,  "Now you are a hellicopter!!") 
}
//----------------------------------------------------------------------------------------------
public Copter_unmorph(id)
{
  if ( g_morphed[id] )
  {
    cs_reset_user_model(id) 
    set_hudmessage(200, 200, 0, 0.35, 0.45, 2, 0.02, 2.0, 0.01, 0.1, 2) 
    show_hudmessage(id,"No longer a hellicopter!") 
    g_morphed[id]=false
  }
}
//----------------------------------------------------------------------------------------------
public Copter_death()
{
  new victim
  
  new id=read_data(2)
  
  victim = read_data(2)
  remove_task(35632+victim)
  is_scan_rocket[victim] = 0	
  Copter_unmorph(id)
}
//----------------------------------------------------------------------------------------------
public forceUnmorph(parm[])
{
  new id= parm[0]
  Copter_unmorph(id)  
}
//----------------------------------------------------------------------------------------------